--Script by: SpectrumUK
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MF_ENEMY = MF_ENEMY
local MF_NOTHINK = MF_NOTHINK
local MF_NOCLIPTHING = MF_NOCLIPTHING
local MF2_SHADOW = MF2_SHADOW
local MF2_OBJECTFLIP = MF2_OBJECTFLIP
local respawnvariable = CV_FindVar("respawnitem")
local respawntime = CV_FindVar("respawnitemtime")
local respawnenemytable = {}

addHook("MobjSpawn", function(mo)
	mo.spawnx = mo.x
	mo.spawny = mo.y
	mo.spawnz = mo.z
end)

addHook("MobjDeath", function(mo)
	if not mo.valid then return end
	if not (mo.flags & MF_ENEMY) then return end
	local mospawnpoint = mo.spawnpoint
	respawntime = $ or CV_FindVar("respawnitemtime")
	if not (mospawnpoint and mospawnpoint.valid) then return end
	local respawned = P_SpawnMobjFromMobj(mo, mo.spawnx - mo.x, mo.spawny - mo.y, mo.spawnz - mo.z, MT_THOK)
	respawned.sprite = mo.sprite
	respawned.spawnpoint = mospawnpoint
	respawned.angle = mospawnpoint.angle
	respawned.pitch = mospawnpoint.pitch
	respawned.roll = mospawnpoint.roll
	respawned.flags = $|MF_NOTHINK|MF_NOCLIPTHING
	respawned.flags2 = $|MF2_SHADOW
	mospawnpoint.mobj = respawned
	table.insert(respawnenemytable, {respawned, mo.type, mospawnpoint, respawntime.value*TICRATE})
end)

addHook("ThinkFrame", function()
	respawnvariable = $ or CV_FindVar("respawnitem")
	if not respawnvariable.value then return end
	if #respawnenemytable
		for i=1, #respawnenemytable
			local k = #respawnenemytable+1-i
			local v = respawnenemytable[k]
			if not v then continue end
			v[4] = $ and $-1 or 0
			if not v[4] or not (v[1] and v[1].valid)
				local respawned = v[1]
				local respawnedtype = v[2]
				local spawnpoint = v[3]
				local respawned2 = P_SpawnMobjFromMobj(respawned, 0, 0, 0, respawnedtype)
				respawned2.spawnpoint = spawnpoint
				respawned2.angle = respawned.angle
				respawned2.pitch = respawned.pitch
				respawned2.roll = respawned.roll
				spawnpoint.mobj = respawned2
				P_RemoveMobj(respawned)
				table.remove(respawnenemytable, k)
			end
		end
	end
end)

addHook("NetVars", function(net)
	respawnenemytable = net($)
end)

addHook("MapChange", function(map)
	respawnenemytable = {}
end)